/********************************* NOTICE *********************************
 * In accordance to the text of the Apache License 2.0 this text notifies
 * you that this file was modified from its original version. For more
 * information on the changes see the file README.patches.
 ***************************** END of NOTICE ******************************/

/*
 * $Id: mailcap.h 971 2008-03-18 17:24:31Z hubert@u.washington.edu $
 *
 * ========================================================================
 * Copyright 2006-2008 University of Washington
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * ========================================================================
 */

#ifndef PITH_MAILCAP_INCLUDED
#define PITH_MAILCAP_INCLUDED


typedef struct mcap_cmd {
    char *command;                              /* command to execute      */
    int   special_handling;                     /* special os handling     */
} MCAP_CMD_S;


/* exported protoypes */
char       *mc_conf_path(char *, char *, char *, int, char *);
int	    mailcap_can_display(int, char *, BODY *, int);
MCAP_CMD_S *mailcap_build_command(int, char *, BODY *, char *, int *, int);
void	    mailcap_free(void);
char 	   *mc_template(char *, BODY *, int);

/* currently mandatory to implement stubs */

/* return exit status of test command */
int	exec_mailcap_test_cmd(char *);



#endif /* PITH_MAILCAP_INCLUDED */
